/// <reference path="../../../typings/node/node.d.ts"/>
/// <reference path="../../../typings/mocha/mocha.d.ts"/>
var Promise_1 = require("../../main/ts/Promise");
var assert = require("assert"), Promise = Promise_1.CorePromise;
var adapter = {
    /**
     * resolved - Create a resolved promise.
     * @param {any} value
     * @return {Promise}
     */
    resolved: function (value) {
        return Promise_1.CorePromise.resolve(value);
    },
    /**
     * rejected - Create a rejected promise
     * @param {} value
     * @return {Promise}
     */
    rejected: function (value) {
        return Promise_1.CorePromise.reject(value);
    },
    deferred: function () {
        var result, _fulfill, _reject;
        result = new Promise_1.CorePromise(function (fulfill, reject) {
            _fulfill = fulfill;
            _reject = reject;
        });
        return {
            promise: result,
            resolve: function (v) {
                try {
                    _fulfill(v);
                }
                catch (e1) {
                    console.log("ERROR:", e1);
                }
            },
            reject: function (e) {
                try {
                    _reject(e);
                }
                catch (e2) {
                    console.log("ERROR:", e2);
                }
            }
        };
    },
    defineGlobalPromise: function (global) {
        global.Promise = Promise_1.CorePromise;
        global.assert = assert;
    },
    removeGlobalPromise: function (global) {
    }
};
describe("Promises/A+ Tests", function () {
    require("promises-aplus-tests").mocha(adapter);
});
describe("Promise ES6 Tests", function () {
    require("promises-es6-tests").mocha(adapter);
});
//# sourceMappingURL=test_promise.js.map